#
# armazena array com  attributos e propriedades
#
proc DB_attrprop { db class varname } {
	upvar $varname var
	set conn [pg_connect $db]
    set query "select a.attname,t.typname,a.attlen,a.atttypmod from \
        pg_attribute a, pg_class c, pg_type t \
        where a.attrelid = c.oid \
        and c.relname = '$class' \
        and a.attnum > 0 \
        and a.atttypid = t.oid"
	set i 0
    pg_select $conn $query v { 
		if {$v(attlen) == -1} {
			set len [expr $v(atttypmod) - 4]
		} else {
			set len $v(attlen)
		}
		set var($i,attname) $v(attname)
		set var($i,attlen) $len
		set var($i,atttyp) $v(typname)
		incr i
	}
	pg_disconnect $conn
}

#
# retorna lista de atributos de uma classe (tabela)
#
proc DB_attributes { db class } {
	set conn [pg_connect $db]
    set query "select a.attname from \
        pg_attribute a, pg_class c, pg_type t \
        where a.attrelid = c.oid \
        and c.relname = '$class' \
        and a.attnum > 0 \
        and a.atttypid = t.oid"
    set result {}
    pg_select $conn $query v { lappend result $v(attname) }
	pg_disconnect $conn
    return $result
}

#
# retorna lista de classes (tabelas) no banco de dados
#
proc DB_classes { db } {
	set conn [pg_connect $db]
    set query "select relname from pg_class \
        where relname !~ '^pg_' \
        and relkind <> 'i'"
    set result {}        
    pg_select $conn $query v { lappend result $v(relname) }
	pg_disconnect $conn
    return $result        
}

#
# retorna bancos de dados existentes
#
proc DB_databases { } {
	set conn [pg_connect template1]
	set dblist ""
	set query "select datname from pg_database where datname !~ 'template1' \
		order by datname"
	pg_select $conn $query v {
		lappend dblist $v(datname)
	}
	pg_disconnect $conn
	return $dblist
}

